SystemOrganization addCategory: #'GsUpgrader-Core'!

Object subclass: #GsUpgrader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GsUpgrader-Core'!

!GsUpgrader commentStamp: '' prior: 0!
for more information see https://github.com/GsDevKit/gsUpgrader#gsupgrader-!

!GsUpgrader class methodsFor: 'batch support' stamp: 'dkh 03/17/2015 18:54'!
batchErrorHandlingDo: aBlock
  aBlock
    on: Error , Halt
    do: [ :ex | 
      Transcript
        cr;
        show: '========>Server Stack: ' , ex description printString;
        cr;
        show: (GsProcess stackReportToLevel: 500).
      Transcript
        cr;
        show: '========>Client Stack: ';
        cr.
      ex pass ]! !

!GsUpgrader class methodsFor: 'analysis' stamp: 'dkh 09/11/2014 16:35'!
metacelloReport
  "produce a report listing the configurations, baselines and packages loaded in the image"

  | strm |
  strm := WriteStream on: String new.
  self metacelloReportOn: strm.
  ^ strm contents! !

!GsUpgrader class methodsFor: 'analysis' stamp: 'dkh 09/11/2014 16:35'!
metacelloReportOn: strm
  "produce a report listing the configurations, baselines and packages loaded in the image"

  self new
    projectReportOn: strm;
    packageReportOn: strm! !

!GsUpgrader class methodsFor: 'projects' stamp: 'dkh 11/16/2014 19:20'!
unregisterGLASS
  "unregister GLASS, GsCore, GsMisc, GsMonticello and GsOB projects"

  self new unregisterGLASS! !

!GsUpgrader class methodsFor: 'projects' stamp: 'dkh 11/16/2014 19:20'!
unregisterGLASS1
  "unregister GLASS and GLASS1 projects"

  self new unregisterGLASS1! !

!GsUpgrader class methodsFor: 'projects' stamp: 'dkh 09/11/2014 16:09'!
upgradeGLASS
  "Ensure that your image is upgraded to GLASS1.0-beta.9.3"

  self new upgradeGLASS! !

!GsUpgrader class methodsFor: 'projects' stamp: 'dkh 09/11/2014 16:21'!
upgradeGLASS1
  "Ensure that your image is upgraded to the latest version of GLASS1"

  self new upgradeGLASS1! !

!GsUpgrader class methodsFor: 'projects' stamp: 'dkh 09/11/2014 16:21'!
upgradeGrease
  "Ensure that your image is upgraded to the latest version of Grease"

  self new upgradeGrease! !

!GsUpgrader class methodsFor: 'projects' stamp: 'dkh 10/21/2014 13:07'!
upgradeGsDevKit
  "Ensure that your image is upgraded to the latest version of GsDevKit"

  self new upgradeGsDevKit! !

!GsUpgrader class methodsFor: 'projects' stamp: 'dkh 09/11/2014 16:21'!
upgradeMetacello
  "Ensure that your image is upgraded to the latest version of Metacello"

  self new upgradeMetacello! !

!GsUpgrader methodsFor: 'reporting' stamp: 'dkh 09/11/2014 17:03'!
configurationVersionReportOn: strm
  "configuration versions"

  | count |
  count := 1.
  strm
    nextPutAll: '------------------------';
    cr;
    nextPutAll: 'Metacello Version REPORT';
    cr;
    nextPutAll: '------------------------';
    cr.
  ((Object allSubclasses
    select: [ :cl | 
      cl isMeta not
        and: [ cl isMetacelloConfig and: [ cl name asString beginsWith: 'ConfigurationOf' ] ] ])
    sort: [ :a :b | a name < b name ])
    collect: [ :each | 
      | cv |
      cv := each project currentVersion.
      cv ~~ nil
        ifTrue: [ 
          strm nextPutAll: count printString , '. '.
          strm
            nextPutAll:
                each name asString , '	' , cv versionNumber printString , '	'
                    , cv blessing printString;
            cr.
          count := count + 1 ] ]! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/15/2014 11:21'!
deploy: aBlock
  (Smalltalk at: #'GsDeployer' ifAbsent: [  ])
    ifNil: [ 
      | oldAutoCommit oldAutoMigrate |
      oldAutoCommit := MCPlatformSupport autoCommit.
      oldAutoMigrate := MCPlatformSupport autoMigrate.
      MCPlatformSupport autoCommit: true.
      MCPlatformSupport autoMigrate: true.
      [ MCPlatformSupport commitOnAlmostOutOfMemoryDuring: aBlock ]
        ensure: [ 
          MCPlatformSupport autoCommit: oldAutoCommit.
          MCPlatformSupport autoMigrate: oldAutoMigrate ] ]
    ifNotNil: [ :deployerClass | deployerClass deploy: aBlock ]! !

!GsUpgrader methodsFor: 'testing' stamp: 'dkh 09/11/2014 09:46'!
glass1Loaded
  ^ self standardBaselineLoaded: 'BaselineOfGLASS1'! !

!GsUpgrader methodsFor: 'testing' stamp: 'dkh 03/17/2015 20:13'!
glass1Locked
  (self metacelloClass registry
    baseline: [ :spec | spec name = 'GLASS1' ];
    list)
    do: [ :glass1Spec | 
      glass1Spec isLocked
        ifTrue: [ ^ true ] ].
  ^ false! !

!GsUpgrader methodsFor: 'testing' stamp: 'dkh 09/05/2014 13:06'!
glass1Present
  Smalltalk at: #'BaselineOfGLASS1' ifPresent: [ :ignored | ^ true ].
  ^ false! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/05/2014 13:04'!
glass1RepositoryDescription
  ^ 'github://glassdb/glass:master/repository'! !

!GsUpgrader methodsFor: 'testing' stamp: 'dkh 09/12/2014 10:45'!
greaseBaselineLoaded
  ^ self standardBaselineLoaded: 'BaselineOfGrease'! !

!GsUpgrader methodsFor: 'testing' stamp: 'dkh 09/10/2014 15:01'!
greaseLocked
  (self metacelloClass image
    baseline: [ :spec | spec name = 'Grease' ];
    list)
    do: [ :greaseSpec | 
      greaseSpec isLocked
        ifTrue: [ ^ true ] ].
  ^ false! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/11/2014 09:35'!
greaseRepositoryDescription
  ^ 'github://GsDevKit/Grease:master/repository'! !

!GsUpgrader methodsFor: 'testing' stamp: 'dkh 10/21/2014 13:09'!
gsDevKitLoaded
  ^ self standardBaselineLoaded: 'BaselineOfGsDevKit'! !

!GsUpgrader methodsFor: 'testing' stamp: 'dkh 10/21/2014 13:10'!
gsDevKitPresent
  Smalltalk at: #'BaselineOfGsDevKit' ifPresent: [ :ignored | ^ true ].
  ^ false! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 10/21/2014 13:11'!
gsDevKitRepositoryDescription
  ^ 'github://GsDevKit/GsDevKit:master/repository'! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/05/2014 16:56'!
inform: message
  self log: message.
  super inform: message! !

!GsUpgrader methodsFor: 'loading' stamp: 'dkh 03/17/2015 14:07'!
loadGLASS1
  | metacello |
  self upgradeMetacello.
  metacello := self glass1Locked
    ifTrue: [ self metacelloClass registry ]
    ifFalse: [ 
      self metacelloClass new
        repository: self glass1RepositoryDescription;
        yourself ].
  metacello baseline: 'GLASS1'.
  self
    deploy: [ 
      "May be running with an old version of Metacello so copy the Metacello instance"
      self log: 'Installing GLASS1'.
      metacello copy get.
      metacello copy load ]! !

!GsUpgrader methodsFor: 'loading' stamp: 'dkh 09/15/2014 11:22'!
loadGreaseBaseline
  | metacello |
  self upgradeMetacello.
  metacello := self metacelloClass new
    baseline: 'Grease';
    repository: self greaseRepositoryDescription;
    yourself.
  self
    deploy: [ 
      self log: 'Installing Grease'.
      metacello copy get.
      metacello copy load ]! !

!GsUpgrader methodsFor: 'loading' stamp: 'dkh 10/21/2014 13:11'!
loadGsDevKit
  | metacello |
  self upgradeMetacello.
  metacello := self metacelloClass new
    baseline: 'GsDevKit';
    repository: self gsDevKitRepositoryDescription;
    yourself.
  self
    deploy: [ 
      self log: 'Installing GsDevKit'.
      metacello
        get;
        load ]! !

!GsUpgrader methodsFor: 'loading' stamp: 'dkh 09/16/2014 11:18'!
loadMetacelloBootstrap10beta311
  "load basic Metacello packages for version 1.0-beta.31.1. 
   To load GLASS 1.0-beta.8.7.1:
     - Metacello must handle symbolic versions
	  - MetacelloSkipDirtyPackageLoad needs to be defined"

  (self projectVersion: 'ConfigurationOfMetacello') versionNumber
    > '1.0-beta.31.1' asMetacelloVersionNumber
    ifTrue: [ ^ self ].
  self log: 'Bootstrapping Metacello1.0-beta.31.1'.
  (Smalltalk at: #'Gofer') new
    url: 'http://seaside.gemtalksystems.com/ss/metacello';
    version: 'Metacello-Base-DaleHenrichs.19';
    version: 'Metacello-Core-dkh.468';
    version: 'Metacello-MC-dkh.531';
    load.
  (Smalltalk at: #'Gofer') new
    url: 'http://seaside.gemtalksystems.com/ss/metacello';
    version: 'Metacello-Platform.gemstone-dkh.23';
    load! !

!GsUpgrader methodsFor: 'loading' stamp: 'dkh 09/16/2014 13:10'!
loadMetacelloPreview
  "Bootstrap Metacello Preview, using mcz files (#'previewBootstrap' symbolic version"

  self metacelloPreviewLoaded
    ifTrue: [ 
      self log: 'Metacello Preview already loaded'.
      ^ self ].
  self
    deploy: [ 
      self metacelloBootstrap10beta311Loaded
        ifFalse: [ self loadMetacelloBootstrap10beta311 ].
      self log: 'Loading Metacello Preview'.
      Gofer new
        url: 'http://seaside.gemtalksystems.com/ss/metacello';
        package: 'ConfigurationOfMetacello';
        load.	"load the Metacello Preview"
      ((Smalltalk at: #'ConfigurationOfMetacello') project
        version: #'previewBootstrap') load.
      (Smalltalk at: #'Metacello') new
        configuration: 'MetacelloPreview';
        version: #'stable';
        repository: self metacelloPreviewRepositoryDescription;
        load ]! !

!GsUpgrader methodsFor: 'locking' stamp: 'dkh 09/15/2014 11:22'!
lockGrease
  self greaseLocked
    ifTrue: [ ^ self ].
  self log: 'Locking Grease'.
  self
    deploy: [ 
      self metacelloClass new
        baseline: 'Grease';
        repository: self greaseRepositoryDescription;
        lock ]! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/05/2014 16:53'!
log: message
  Transcript
    cr;
    show: '======================';
    cr;
    show: '=====' , message! !

!GsUpgrader methodsFor: 'testing' stamp: 'dkh 09/16/2014 11:20'!
metacelloBootstrap10beta311Loaded
  ^ (self projectVersion: 'ConfigurationOfMetacello') versionNumber
    > '1.0-beta.31.1' asMetacelloVersionNumber! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/10/2014 15:01'!
metacelloClass
  ^ Smalltalk at: #'Metacello'! !

!GsUpgrader methodsFor: 'testing' stamp: 'dkh 09/11/2014 09:46'!
metacelloPreviewLoaded
  ^ self standardBaselineLoaded: 'BaselineOfMetacello'! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/05/2014 12:23'!
metacelloPreviewRepositoryDescription
  ^ 'github://dalehenrich/metacello-work:configuration'! !

!GsUpgrader methodsFor: 'reporting' stamp: 'dkh 09/15/2014 13:49'!
metacelloRegistrationReportOn: strm
  | map |
  strm
    nextPutAll: '-----------------------------';
    cr;
    nextPutAll: 'Metacello Registration REPORT';
    cr;
    nextPutAll: '-----------------------------';
    cr.
  map := Dictionary new.
  MetacelloProjectRegistration registry projectSpecs
    do: [ :projectSpec | 
      MetacelloProjectRegistration
        registrationForProjectSpec: projectSpec
        ifAbsent: [ self error: 'registration for projectSpec: ' projectSpec name , ' not found' ]
        ifPresent: [ :registration :ignored | map at: registration baseName put: registration ] ].
  (map values sortWithBlock: [ :a :b | a baseName < b baseName ])
    do: [ :registration | 
      | isLoaded isLocked |
      isLocked := registration locked.
      isLoaded := registration loadedInImage.
      isLoaded
        ifFalse: [ strm nextPutAll: '<' ].
      isLocked
        ifTrue: [ strm nextPutAll: '|' ].
      strm nextPutAll: registration baseName.
      isLocked
        ifTrue: [ strm nextPutAll: '|' ].
      strm space.
      (registration respondsTo: #'currentVersionString')
        ifTrue: [ 
          strm
            nextPutAll:
              registration currentVersionString , ' [' , registration currentBranchName , ']' ]
        ifFalse: [ strm nextPutAll: registration projectSpec versionString ].
      isLoaded
        ifFalse: [ strm nextPutAll: '>' ].
      strm cr ]! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/05/2014 12:23'!
metacelloRepositoryDescription
  ^ 'github://dalehenrich/metacello-work:master/repository'! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/05/2014 16:56'!
notify: message
  self log: message.
  super notify: message! !

!GsUpgrader methodsFor: 'reporting' stamp: 'dkh 09/15/2014 13:48'!
packageReportOn: strm
  strm
    nextPutAll: '--------------';
    cr;
    nextPutAll: 'PACKAGE REPORT';
    cr;
    nextPutAll: '--------------';
    cr.
  (MCWorkingCopy allManagers
    sortWithBlock: [ :a :b | a packageName < b packageName ])
    do: [ :wc | 
      strm
        nextPutAll: wc ancestry ancestorString;
        cr ]! !

!GsUpgrader methodsFor: 'reporting' stamp: 'dkh 09/11/2014 16:38'!
projectReportOn: strm
  "Use registraion and get configuration/baseline versions otherwise get configuration versions"

  self metacelloPreviewLoaded
    ifTrue: [ self metacelloRegistrationReportOn: strm ]
    ifFalse: [ self configurationVersionReportOn: strm ]! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/15/2014 13:13'!
projectVersion: configurationClassName
  ^ self metacelloPreviewLoaded
    ifTrue: [ 
      (MetacelloProjectRegistration
        projectSpecForClassNamed: configurationClassName
        ifAbsent: [ ^ nil ]) version asMetacelloVersionNumber ]
    ifFalse: [ (Smalltalk at: configurationClassName) project currentVersion ]! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 11/16/2014 20:06'!
registrationFor: className
  Smalltalk
    at: className
    ifPresent: [ :ignored | 
      Smalltalk
        at: #'MetacelloProjectRegistration'
        ifPresent: [ :cls | 
          (cls registrationForClassNamed: className ifAbsent: [  ])
            ifNotNil: [ :registration | ^ registration ] ] ].
  ^ nil! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/11/2014 09:45'!
standardBaselineLoaded: baselineClassName
  Smalltalk
    at: baselineClassName
    ifPresent: [ :ignored | 
      Smalltalk
        at: #'MetacelloProjectRegistration'
        ifPresent: [ :cls | 
          (cls registrationForClassNamed: baselineClassName ifAbsent: [  ])
            ifNotNil: [ :registration | ^ registration loadedInImage ] ] ].
  ^ false! !

!GsUpgrader methodsFor: 'private' stamp: 'dkh 09/24/2014 10:45'!
standardUpgrade: projectName repository: repositoryDescription
  | specs projectSpec metacello |
  specs := self metacelloClass image
    baseline: [ :spec | spec name = projectName ];
    list.
  specs isEmpty
    ifFalse: [ projectSpec := specs first ].
  (projectSpec notNil and: [ projectSpec isLocked ])
    ifTrue: [ 
      projectSpec repositorySpecs
        detect: [ :repoSpec | repoSpec description = repositoryDescription ]
        ifNone: [ 
          self
            notify:
              projectName , ' project repository is not in standard location ('
                , self metacelloRepositoryDescription , '). The upgrade of '
                , projectName , ' may not be complete.' ].
      metacello := self metacelloClass image baseline: projectName ]
    ifFalse: [ 
      metacello := self metacelloClass new
        baseline: projectName;
        repository: repositoryDescription;
        yourself ].
  self
    deploy: [ 
      self log: 'Upgrading ' , projectName.
      metacello copy get.
      metacello copy load ]! !

!GsUpgrader methodsFor: 'unregistering' stamp: 'dkh 03/17/2015 13:58'!
unregisterGLASS
  "unregister GLASS, GsCore, GsMisc, GsMonticello and GsOB projects"

  self error: 'Do not use until public announcement'.
  #('ConfigurationOfGLASS' 'ConfigurationOfGsCore' 'ConfigurationOfGsMisc' 'ConfigurationOfGsMonticello' 'ConfigurationOfGsOB')
    do: [ :className | 
      (self registrationFor: className)
        ifNotNil: [ :registration | registration unregisterProject ] ]! !

!GsUpgrader methodsFor: 'unregistering' stamp: 'dkh 03/17/2015 13:59'!
unregisterGLASS1
  "unregister GLASS1"

  self error: 'Do not use until public announcement'.
  self unregisterGLASS.
  #('BaselineOfGLASS1')
    do: [ :className | 
      (self registrationFor: className)
        ifNotNil: [ :registration | registration unregisterProject ] ]! !

!GsUpgrader methodsFor: 'upgrading' stamp: 'dkh 10/16/2014 17:06'!
upgradeGLASS
  "skip this step if GLASS1 is already loaded"

  | glassVersion originalVersion |
  self glass1Loaded
    ifTrue: [ 
      self inform: 'GLASS1 is loaded. Skipping GLASS upgrade.'.
      ^ self ].
  self metacelloPreviewLoaded
    ifTrue: [ 
      self inform: 'MetacelloPreview is loaded. Skipping GLASS upgrade.'.
      ^ self ].
  glassVersion := self projectVersion: 'ConfigurationOfGLASS'.
  glassVersion versionNumber < '1.0-beta.9.3' asMetacelloVersionNumber
    ifTrue: [ 
      self log: 'Upgrading GLASS to 1.0-beta.9.3'.
      self
        deploy: [ 
          Gofer new
            package: 'ConfigurationOfGLASS';
            url: 'http://seaside.gemtalksystems.com/ss/MetacelloRepository';
            load.
          glassVersion versionNumber < '1.0-beta.9.2' asMetacelloVersionNumber
            ifTrue: [ 
              self metacelloBootstrap10beta311Loaded
                ifFalse: [ self loadMetacelloBootstrap10beta311 ].
              [ 
              [ 
              Gofer new
                url: 'http://seaside.gemtalksystems.com/ss/MetacelloRepository';
                package: 'ConfigurationOfGofer';
                package: 'ConfigurationOfMetacello';
                package: 'ConfigurationOfGsCore';
                package: 'ConfigurationOfGoferProjectLoader';
                package: 'ConfigurationOfGsMonticello';
                package: 'ConfigurationOfGsOB';
                package: 'ConfigurationOfGsMisc';
                package: 'ConfigurationOfGsSqueakCommon';
                load ]
                on: Warning
                do: [ :ex | 
                  self log: ex description.
                  ex resume ].
              ((Smalltalk at: #'ConfigurationOfMetacello') project
                version: #'previewBootstrap') load.
              ((Smalltalk at: #'ConfigurationOfGLASS') project
                version: '1.0-beta.9.2') load: #('Core' 'Monticello').
              ((Smalltalk at: #'ConfigurationOfGLASS') project
                version: '1.0-beta.9.2') load ]
                on: (Smalltalk at: #'MetacelloSkipDirtyPackageLoad')
                do: [ :ex | ex resume: false ] ]
            ifFalse: [ 
              "explicitly load Metacello #previewBootstrap"
              Gofer new
                url: 'http://seaside.gemtalksystems.com/ss/metacello';
                package: 'ConfigurationOfMetacello';
                load.
              ((Smalltalk at: #'ConfigurationOfMetacello') project
                version: #'previewBootstrap') load ].
          self upgradeGofer.
          ((Smalltalk at: #'ConfigurationOfGLASS') project
            version: '1.0-beta.9.3') load.
          #('GsCore' 'GsMonticello' 'GsOB' 'GsMisc')
            do: [ :gsProjectName | 
              "Patch registrations with proper repository"
              self metacelloClass image
                configuration: gsProjectName;
                repository:
                    'http://seaside.gemtalksystems.com/ss/MetacelloRepository';
                register ] ] ]
    ifFalse: [ self log: 'GLASS already upgraded to 1.0-beta.9.3' ]! !

!GsUpgrader methodsFor: 'upgrading' stamp: 'dkh 09/11/2014 09:48'!
upgradeGLASS1
  | metacello projectSpec |
  self glass1Loaded
    ifFalse: [ 
      self upgradeGLASS.
      self glass1Present
        ifFalse: [ 
          ^ self
            loadGLASS1;
            upgradeGrease ] ].
  self
    upgradeMetacello;
    upgradeGrease;
    standardUpgrade: 'GLASS1' repository: self glass1RepositoryDescription! !

!GsUpgrader methodsFor: 'upgrading' stamp: 'dkh 10/16/2014 13:13'!
upgradeGofer
  "https://github.com/GsDevKit/gsUpgrader/issues/10"

  "should only be called from upgradeGLASS..."

  self log: 'Upgrading Gofer to #stable'.
  [ 
  Gofer new
    url: 'http://seaside.gemtalksystems.com/ss/MetacelloRepository';
    package: 'ConfigurationOfGofer';
    load ]
    on: Warning
    do: [ :ex | 
      self log: ex description.
      ex resume ].
  ((Smalltalk at: #'ConfigurationOfGofer') project version: #'stable') load! !

!GsUpgrader methodsFor: 'upgrading' stamp: 'dkh 09/12/2014 10:48'!
upgradeGrease
  self greaseBaselineLoaded
    ifTrue: [ 
      self
        upgradeMetacello;
        standardUpgrade: 'Grease' repository: self greaseRepositoryDescription ]
    ifFalse: [ self loadGreaseBaseline ].
  self lockGrease! !

!GsUpgrader methodsFor: 'upgrading' stamp: 'dkh 10/21/2014 13:09'!
upgradeGsDevKit
  | metacello projectSpec |
  self gsDevKitLoaded
    ifFalse: [ 
      self upgradeGLASS.
      self gsDevKitPresent
        ifFalse: [ 
          ^ self
            loadGsDevKit;
            upgradeGrease ] ].
  self
    upgradeMetacello;
    upgradeGrease;
    standardUpgrade: 'GsDevKit' repository: self gsDevKitRepositoryDescription! !

!GsUpgrader methodsFor: 'upgrading' stamp: 'dkh 09/11/2014 09:42'!
upgradeMetacello
  self
    loadMetacelloPreview;
    standardUpgrade: 'Metacello'
      repository: self metacelloRepositoryDescription! !
